#!/usr/bin/php
<?php
$script_header = "
#***********************************************************
# Simple LightControl script for cirrus7 LED panels
#
# Version: 0.4.6-BETA (12-02-2013)
#
# (c) by Andreas Erhard 2011-2013
#
# WischMoB Solutions http://wischmob.ilo.de 
#***********************************************************
";

$path = "/home/andreas/Dokumente/scripts/lightshow/"; // absolute path to the scripts (like /home/user/scripts/)
$verbose = 1; // debug output
$tty_device = "/dev/ttyUSB0";


############# DO NOT EDIT BELOW UNLESS YOU KNOW WHAT YOU ARE DOING #############################
################################################################################################
error_reporting(0);
@ini_set(‘display_errors’, 0);


$last_color = "";

system("stty -F ".$tty_device." 9600 raw -hupcl min 0"); // Initialise the LED panels
usleep(25);

$colors = array("r", "g", "b", "y", "p", "c", "w", "o"); // array with all possible colors
$mode = $argv[1]; // the first parameter is the mode, the following params are the options
$show_manual = 0;
if(!$mode){
	// if there are no parameters set, show the help
	$show_manual = 1;
}

switch($mode){

	# <TESTS> ########################################################
	case "test": // define LED colors blockwise
	echo_lc("s D y y y y b b b b r r r r");
echo_lc("t s 5");
echo "TEST\n";
break;

	case "test2": // define color for every single LED
		echo_lc("s D b y r b y b r y r b y r");
		echo_lc("t s 5");
		echo "TEST\n";
		break;

	case "test3": // clockwise and anti-clockwise color rotation
		echo "TEST\n";

		$delay = 60000;

		$str = "r r r r g g g g b b b b ";
		$rotated = $str;
		$n = 2; // 2
		$limit = 12; // 12

		for($ix=0; $ix <= 2; $ix++){

			system("stty -F /dev/ttyUSB0 9600 raw -hupcl min 0"); // Initialise the LED panels
			usleep(25);

			for($i=0; $i<=$limit; $i++){
				// anti-clockwise
				echo_lc("s D $rotated");
				echo_lc("t i");

				usleep($delay);

				if($i != $limit){
					$rotated = substr($rotated, -$n).substr($rotated, 0, -$n); //clockwise
				}
			}

			//echo "#########\n";

			for($i=0; $i<=$limit; $i++){
				echo_lc("s D $rotated");
				echo_lc("t i");

				usleep($delay);

				if($i != $limit){
					$rotated = substr($rotated, $n).substr($rotated, 0, $n); //anti-clockwise
				}
			}

		}


		break;


	case "test5":

		$delay = "t i";
		$usleep = 10000000;

		$str = array(
			"r r r r g g g g r r r r", # 0
			"r r r g g g g g g r r r", # 1 
			"r r g g g g g g g g r r", # 2
			"r g g g g g g g g g g r", # 3
			"g g g g g g g g g g g g", # 4
			"g g g g r r r r g g g g", # 5
			"g g g r r r r r r g g g", # 6
			"g g r r r r r r r r g g", # 7  
			"g r r r r r r r r r r g", # 8 
			"r r r r r r r r r r r r", # 9
		);

		$last_color1 = "g";
		$last_color2 = "r";

		for($i=0; $i < 10; $i++){

			for($xx=0; $xx < 10; $xx++){
				echo_lc("s D $str[$xx]");
				echo_lc($delay);
				usleep($sleep);
			}

			if($i%2 == 0){
				foreach($str as $key => $value){
					$colortmp = get_random_color($last_color2);
					$str[$key] = str_replace($last_color2, $colortmp, $value);
					$last_color2 = $colortmp;
				}
			}else{
				foreach($str as $key => $value){
					$colortmp = get_random_color($last_color1);
					$str[$key] = str_replace($last_color1, $colortmp, $value);
					$last_color1 = $colortmp;
				}
			}
		}

		break;


		# </TESTS> #############################################################################

	###########
	case "off":
			echo_lc("s DA o");
		echo_lc("t s 5");
		break;

	##########
	case "on":
		$color = "b";
		if( $argv[2] && is_string($argv[2]) ){
			$color = string_to_color($argv[2]);
		}
		$ayn = "A";
		if(strlen($color) > 1){
			$ayn = "";
		}
		echo_lc("s D$ayn $color");
		echo_lc("t s 10");
		break;

	#################
	case "lightshow":
		$loops = 500;
		$delay = 30; // in milliseconds
		$sleep = 30; // in seconds

		if( $argv[2] && is_numeric($argv[2])){
			$loops = $argv[2];
		}
		if( $argv[3] && is_numeric($argv[3]) ){
			$delay = $argv[3];
		}
		if( $argv[4] && is_numeric($argv[4]) ){
			$sleep = $argv[4];
		}

		$count = 1;
		while($count <= $loops){
			if($verbose == 1){
				echo "$count - ";
				echo random_fade($delay)."\n";
			}
			sleep($sleep); // wait 30sek to next color transition
			$count++;
		}

		break;

	#############
	case "blink":
		$color = "b";
		$anz = 15;
		$delay = 0;
		$sleep = 1;
		$interrupt = "y";

		// check the parameters and replace the defaults
		if( $argv[2] && is_string($argv[2]) ){
			$color = $argv[2];
		}
		if( $argv[3] && is_numeric($argv[3]) ){
			$anz = $argv[3];
		}
		if( $argv[4] && is_numeric($argv[4]) ){
			$delay = $argv[4];
		}
		if( $argv[5] && is_numeric($argv[5]) ){
			$sleep = $argv[5];
		}
		if( $argv[6] && $argv[6] == "n"){
			$interrupt = "n";
		}

		blink($color, $anz, $delay, $sleep, $interrupt);
		break;

	###############
	case "bluered":

		$loops = 10;
		$delay = 5;
		if( $argv[2] && is_numeric($argv[2])){
			$loops = $argv[2];
		}
		if( $argv[3] && is_numeric($argv[3]) ){
			$delay = $argv[3];
		}

		for($ix=0; $ix < $loops; $ix++){
			echo_lc("s D b r b r b b b b r b r b");
			echo_lc("t s $delay");
			sleep($delay);
			echo_lc("s D r b r b r r r r b r b r");
			echo_lc("t s $delay");
			sleep($delay);

		}
		break;


	###########
	case "rgb":
		$sleep = 200000;
		$loops = 10;

		if( $argv[2] && is_numeric($argv[2])){
			$loops = $argv[2];
		}
		if( $argv[3] && is_numeric($argv[3]) ){
			$sleep = $argv[3]*10000;
		}

		for($i=0; $i<$loops; $i++){
			$str = "r r r r g g g g o o o o";
			echo_lc("s D $str");
			echo_lc("t s 0");

			usleep($sleep);

			$str = "o o o o g g g g b b b b";
			echo_lc("s D $str");
			echo_lc("t s 0");

			usleep($sleep);
		}
		sleep(3);
		$str = "r r r r g g g g b b b b";
		echo_lc("s D $str");
		echo_lc("t s 3");
		
		break;


	########
	default:
		$show_manual = 1;

}

if($show_manual == 1){
	echo $script_header;
	echo show_usage();
	exit;
}



########################
# Methods and Functions
########################

function show_usage(){
	return "\nusage: $argv[0] mode [options]
	
	Colors: r,g,b,c,y,w,p,o (Red, Green, Blue, Cyan, Yellow, White, Pink, Off)
		use 'x' for random color
		
	Modes:
	- on: switch the LEDs on and set color to blue
		on [color]
	- off: switch the LEDs off
	- lightshow: execute a random-color-change-loop 
		lightshow [number of loops] [fade msec.] [sleep sec.]
	- blink: simple blinking effect
		blink [color] [number] [fade msec.] [sleep sec.] [interrupt (y/n)]
	- bluered: light animation with red and blue
		bluered [number] [fade msec.]	
	- rgb: special rgb color animation
		rgb [number] [sleep msec.]

	Examples: 
	$argv[0] blink r 25 1 0
	$argv[0] blink x 15 2 1 n
	$argv[0] lightshow 5 30 25
	$argv[0] on rrrrbbbbgggg
	$argv[0] on cyr
	\n";
}

function random_fade($delay){
	global $last_color;
	global $colors;

	$colors_name = array("r" => "Red", // color names
			"g" => "Green",
			"b" => "Blue",
			"y" => "Yellow",
			"p" => "Pink",
			"c" => "Cyan",
			"w" => "White");

	$color = get_random_color();

	echo_lc("s DA $color");
	echo_lc("t s $delay");

	usleep($delay); // wait till the transition finished

	$long = $colors_name[$color];
	return $long; // return the name of the new color
}

function blink($color, $quantity, $delay, $sleep, $interrupt){
	global $last_color;
	while($quantity > 0){
		if($color == "x"){
			$colorx = get_random_color();
		}else{
			$colorx = $color;
		}

		if($interrupt == "y"){
			// fade off, before fade to next color
			echo_lc("s DA o"); // set off
			echo_lc("t s $delay"); // do fade
			sleep($sleep);
		}

		echo_lc("s DA $colorx");
		echo_lc("t s $delay");
		usleep($delay);
		sleep($sleep);

		$quantity--;
	}
}

function get_random_color($last_colorx=""){
	global $colors;
	global $last_color;
	if($last_colorx != ""){
		$last_color = $last_colorx;
	}

	$rand = rand(0,6);
	while($last_color == $colors[$rand]){
		// make sure to get another color as last time
		$rand = rand(0,6);
	}
	$last_color = $colors[$rand];

	return $colors[$rand]; // return random color
}

function echo_lc($vars){
	global $path;
	global $tty_device;
	system($path."echo_lc.py ".$tty_device." '$vars'"); // call the python helper script

}

function string_to_color($string){
	global $colors;
	$color_names = array("rot"  => "r",
						"grün"  => "g",
						"gruen" => "g",
						"blau"  => "b",
						"gelb"  => "y",
						"pink"  => "p",
						"lila"  => "p",
						"cyan"  => "c",
						"weiss" => "w",
						"weiß"  => "w",
						"red"   => "r",
						"green" => "g",
						"blue"  => "b",
						"yellow"=> "y",
						"pink"  => "p",
						"white" => "w",
						"off"   => "o",
						"aus"   => "o",
						"random"=> get_random_color(),
						"zufall"=> get_random_color(),
						"x"     => get_random_color());
	$string = trim(strtolower($string));

	if(isset($color_names[$string])){

		return $color_names[$string];

	}elseif(in_array($string, $colors)){

		return $string;

	}elseif(strlen($string) == 12 && str_replace($colors,"",$string) == ""){

		$backup = $string;
		$string = "";
		for($i=0; $i < strlen($backup); $i++){
			$string .= $backup[$i]." ";
		}
		return $string;
	
	}elseif(strlen($string) == 3){

		$color = $string;
		if($color[0] == x){
			$color[0] = get_random_color();
		}
		if($color[1] == x){
			$color[1] = get_random_color();
		}
		if($color[2] == x){
			$color[2] = get_random_color();
		}
		$tmp = $color[0]." ".$color[0]." ".$color[0]." ".$color[0]." ".$color[1]." ".$color[1]." ".$color[1]." ".$color[1]." ".$color[2]." ".$color[2]." ".$color[2]." ".$color[2];
		$string = $tmp;
		return $string;

	}else{
		echo "ERROR: string_to_color('".$string."') unknown color'!\n\n";
		echo show_usage();
		exit;
	}
}

?>
